/***************************************************************************

  archive.h

  The GAMBAS archiver

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __ARCHIVE_H
#define __ARCHIVE_H

#include "memory.h"
#include "limit.h"
#include "table.h"

typedef
  struct {
    SYMBOL symbol;
    long pos;
    long len;
    }
  ARCH_SYMBOL;

#ifndef __ARCHIVE_C

EXTERN char *ARCH_project;
EXTERN char *ARCH_project_name;
EXTERN char *ARCH_output;
EXTERN boolean ARCH_verbose;

#endif

PUBLIC void ARCH_init(void);
PUBLIC void ARCH_exit(void);
PUBLIC void ARCH_define_project(char *project);
PUBLIC void ARCH_add_file(char *path);

#endif
