/*

  array.h
  
  Gestion d'un tableau dynamique de taille croissante
   l'aide d'une unique allocation
  
*/

#ifndef _ARRAY_H
#define _ARRAY_H

typedef
  struct {
    long count;
    long max;
    size_t size;
    long inc;
    }
  ARRAY;

#define ARRAY_length ARRAY_count

#define ARRAY_create(data) ARRAY_create_with_size((data), sizeof(**(data)), 16)
#define ARRAY_create_inc(data, inc) ARRAY_create_with_size((data), sizeof(**(data)), (inc))

PUBLIC void ARRAY_create_with_size(void *p_data, size_t size, long inc);
PUBLIC void ARRAY_delete(void *p_data);
PUBLIC void *ARRAY_add(void *p_data);
PUBLIC void *ARRAY_add_void(void *p_data);
PUBLIC long ARRAY_count(void *data);
PUBLIC void *ARRAY_get(void *data, int pos);
PUBLIC void ARRAY_remove_last(void *p_data);

#endif
