/*

  error.h
  
  Gestion des erreurs
  
*/


#ifndef _ERROR_H
#define _ERROR_H

#ifndef _SETJMP_H
#include <setjmp.h>
#endif

#define TRY                                      \
  ERROR_flag = (setjmp(ERROR_get()->env) == 0);  \
  if (!ERROR_flag) ERROR_free();                 \
  if (ERROR_flag) {


#define CATCH  ERROR_free(); } else


/* codes d'erreurs */

#define _ERR(x) ((char *)(x))

#define E_MESSAGE    _ERR(1)
#define E_MEMORY     _ERR(2)
#define E_OPEN	     _ERR(3)
#define E_READ	     _ERR(4)
#define E_SYNTAX     _ERR(5)


typedef
  struct {
    jmp_buf env;
    int code;
    }
  ERROR;

#ifdef _ERROR_C

#define ERROR_BUF_MAX 8
#define ERROR_MSG_MAX 1024

#else

EXTERN boolean ERROR_flag;

#endif /* _ERROR_C */

PUBLIC ERROR *ERROR_get(void);
PUBLIC void ERROR_free(void);
PUBLIC void THROW(char *fmt, ...) NORETURN;
PUBLIC void ERROR_panic(char *error) NORETURN;
PUBLIC void ERROR_print(void);
PUBLIC void PROPAGATE(void);

#endif
