/***************************************************************************

  file.h

  The file management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __FILE_H
#define __FILE_H

#include <sys/time.h>

PUBLIC char *FILE_cat(char *path, ...);
PUBLIC int FILE_buffer_length(void);
PUBLIC char *FILE_get_dir(char *path);
PUBLIC char *FILE_get_ext(char *path);
PUBLIC char *FILE_get_current_dir(void);
PUBLIC char *FILE_set_ext(char *path, char *ext);
PUBLIC boolean FILE_exist(char *path);
PUBLIC time_t FILE_get_time(char *path);
PUBLIC char *FILE_get_name(char *path);

#endif
