/*

  table.h
  
  Gestion des tables de symboles
  
*/

#ifndef _TABLE_H
#define _TABLE_H

#include "array.h"
#include "type.h"

#define NO_SYMBOL (-1)

typedef
  struct {
    short sort;
    short len;
    char *name;
    }
  SYMBOL;

typedef
  enum {
    TF_NORMAL = 0,
    TF_IGNORE_CASE = 1
    }
  TABLE_FLAG;


typedef
  struct _table {
    SYMBOL *symbol;
    TABLE_FLAG flag;
    struct _table *next;
    }
  TABLE;


PUBLIC void TABLE_create(TABLE **result, size_t size, TABLE_FLAG flag);
PUBLIC void TABLE_create_from(TABLE **result, size_t size, char *sym_list[], TABLE_FLAG flag);
PUBLIC void TABLE_delete(TABLE **table);

PUBLIC long TABLE_count(TABLE *table);
PUBLIC char *TABLE_get_symbol_name(TABLE *table, long index);
PUBLIC boolean TABLE_find_symbol(TABLE *table, char *name, int len, SYMBOL **symbol, long *index);
PUBLIC boolean TABLE_add_symbol(TABLE *table, char *name, int len, SYMBOL **symbol, long *index);
PUBLIC void TABLE_sort(TABLE *table);
PUBLIC void TABLE_print(TABLE *table, boolean sort);
/*PUBLIC boolean TABLE_copy_symbol(TABLE *dst, TABLE *src, long index_src, SYMBOL **symbol, long *index);*/
PUBLIC void TABLE_copy_symbol_with_prefix(TABLE *table, long ind_src, char prefix, SYMBOL **symbol, long *index);

PUBLIC SYMBOL *TABLE_get_symbol_sort(TABLE *table, long index);

#define TABLE_get_symbol(table, ind) ((SYMBOL *)ARRAY_get((table)->symbol, ind))

#endif
