/***************************************************************************

  CProcess.h

  The process management class

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CPROCESS_H
#define __CPROCESS_H

#include <sys/types.h>

#include "gambas.h"
#include "Object.h"
#include "CList.h"
#include "CFile.h"

#ifndef __CPROCESS_C
extern GB_DESC NATIVE_Process[];
#endif

typedef
  struct _CPROCESS {
    OBJECT ob;
    struct _CPROCESS *prev;
    struct _CPROCESS *next;
    /*char *param[];*/
    char *cmd;
    pid_t pid;
    int in;
    int out;
    int err;
    int ret;
    unsigned watch : 1;
    unsigned running : 1;
  }
  CPROCESS;

#define THIS OBJECT(CPROCESS)

#endif
