/***************************************************************************

  String.h

  The String management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __STRING_H
#define __STRING_H

#include "value.h"

#define STRING_length(str) (((str) != NULL) ? *((long *)(str) - 1) : 0)

void STRING_new(char **string, char *src, int len);
void STRING_new_value(VALUE *value, char *src, int len);
void STRING_new_constant_value(VALUE *value, char *src, int len);

void STRING_copy_from_value(char **string, VALUE *value);

void STRING_extend(char **string, int new_len);

void STRING_char_value(VALUE *value, char car);
void STRING_void_value(VALUE *value);

void STRING_free(char **string);
void STRING_print(VALUE *value);
int STRING_comp_value(VALUE *str1, VALUE *str2);


#endif /* */
