/*

  variant.h

  Gestion des variant

*/

#ifndef __VARIANT_H
#define __VARIANT_H


#include "String.h"
#include "Object.h"

typedef
  struct {
    long type;
    char value[8];
    }
  VARIANT;

#define VARIANT_copy(src, dst)  (*((long long *)dst) = *((long long *)src))

PRIVATE INLINE void VARIANT_undo(VALUE *val)
{
  if (val->type == T_VARIANT)
    VALUE_conv(val, val->_variant.vtype);
}

PRIVATE INLINE void VARIANT_free(VARIANT *var)
{
  if (var->type == T_STRING)
    STRING_free((char **)var->value);
  else if (TYPE_is_object(var->type))
    OBJECT_unref((void **)var->value);
}

PRIVATE INLINE boolean VARIANT_is_null(VARIANT *var)
{
  if (var->type == T_NULL)
    return TRUE;

  if (var->type == T_STRING && *((char **)var->value) == NULL)
    return TRUE;

  if (TYPE_is_object(var->type) && *((void **)var->value) == NULL)
    return TRUE;

  return FALSE;
}


PRIVATE INLINE void VARIANT_clear(VARIANT *var)
{
  long *p = (long *)var;

  VARIANT_free(var);

  p[0] = 0;
  p[1] = 0;
  p[2] = 0;
}



#endif
