/***************************************************************************

  archive.h

  The archive management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __ARCHIVE_H
#define __ARCHIVE_H

#include "table.h"

typedef
  struct {
    long magic;
    long version;
    long pos_data;
    long pos_string;
    long pos_table;
    long n_symbol;
    }
  ARCH_HEADER;

typedef
  struct {
    SYMBOL sym;
    long pos;
    long len;
    }
  ARCH_SYMBOL;

PUBLIC void ARCH_init(char *path);
PUBLIC void ARCH_exit(void);
PUBLIC boolean ARCH_get(char *path, int len_path, long *pos, long *len);
PUBLIC boolean ARCH_read(long pos, void *buffer, long len);

#endif
