/***************************************************************************

  array.h

  C array management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef _ARRAY_H
#define _ARRAY_H

typedef
  struct {
    long count;
    long max;
    size_t size;
    long inc;
    }
  ARRAY;

#define ARRAY_create(data) ARRAY_create_with_size((data), sizeof(**(data)), 16)
#define ARRAY_create_inc(data, inc) ARRAY_create_with_size((data), sizeof(**(data)), (inc))

PUBLIC void ARRAY_create_with_size(void *p_data, size_t size, long inc);
PUBLIC void ARRAY_delete(void *p_data);

PUBLIC void *ARRAY_add(void *p_data);
PUBLIC void *ARRAY_add_void(void *p_data);
PUBLIC void *ARRAY_add_many(void *p_data, int num);

PUBLIC long ARRAY_count(void *data);

PUBLIC void *ARRAY_get(void *data, int pos);

PUBLIC void *ARRAY_insert(void *p_data, long pos);
PUBLIC void ARRAY_remove(void *p_data, long pos);
/*PUBLIC void ARRAY_remove_last(void *p_data);*/

#endif
