/*

  chunk.h
  
  Gestion d'une allocation de 4K
  
*/

#ifndef _CHUNK_H
#define _CHUNK_H

typedef
  struct _CHUNK{
    struct _CHUNK *next;
    struct _CHUNK *next_same;
    void *alloc;
    long size;
    void *free;
    }
  CHUNK;

#define CHUNK_SIZE  4096L

PUBLIC void CHUNK_create(CHUNK *chunk, long size);
PUBLIC void CHUNK_delete(CHUNK *chunk);

PUBLIC void CHUNK_alloc(CHUNK *chunk, void **ptr);
PUBLIC void CHUNK_free(CHUNK *chunk, void **ptr);

#define CHUNK_is_full(chunk) ((chunk)->free == NULL)
#define CHUNK_get_size(chunk) ((chunk)->size)

#endif
