/***************************************************************************

  class_init.c

  Native class initializer

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CLASS_INIT_C

#include "common.h"
#include "memory.h"
#include "error.h"
#include "limit.h"

#include "CGambas.h"
#include "CClass.h"
#include "CError.h"
#include "CCollection.h"
#include "CFile.h"
#include "CApp.h"
#include "CList.h"
#include "CProcess.h"

#include "class.h"

PUBLIC CLASS *CLASS_Array = NULL;
PUBLIC CLASS *CLASS_Class = NULL;
PUBLIC CLASS *CLASS_Collection = NULL;
PUBLIC CLASS *CLASS_Symbol = NULL;
PUBLIC CLASS *CLASS_File = NULL;
PUBLIC CLASS *CLASS_AppArgs = NULL;

/*
   NOTE: La premire classe de la table des symboles DOIT ETRE la classe Class !
*/

typedef
  struct {
    GB_DESC *desc;
    CLASS **class;
    }
  CLASS_INIT;

PRIVATE CLASS_INIT init_list[] =
{
  { NATIVE_Gambas, NULL },
  { NATIVE_Symbol, NULL },
  { NATIVE_ClassSymbols, NULL },
  { NATIVE_Class, NULL },
  { NATIVE_Object, NULL },
  { NATIVE_Collection, &CLASS_Collection },
  { NATIVE_Error, NULL },
  { NATIVE_File, &CLASS_File },
  { NATIVE_AppArgs, &CLASS_AppArgs },
  { NATIVE_App, NULL },
  { NATIVE_List, NULL },
  { NATIVE_Process, NULL },
  { NULL }
};


PUBLIC void CLASS_init_native(void)
{
  CLASS_INIT *init;
  CLASS *class;

  CLASS_Class = CLASS_find("Class"); /* La classe Class doit tre la premire de la table */
  CLASS_Symbol = CLASS_find("Symbol");

  for (init = init_list; init->desc; init++)
  {
    class = CLASS_register(init->desc);
    if (init->class != NULL)
      *init->class = class;
  }
}


