/***************************************************************************

  exec_enum.c

  Enumeration management

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
     
#include "common.h"
#include "limit.h"
#include "exec.h"


PUBLIC void EXEC_enum_first(void)
{
  OBJECT *object;
  CLASS *class;
  boolean defined;
  VALUE *local;

  local = &BP[EXEC_code & 0xFF];

  EXEC_object(local, &class, &object, &defined);
  EXEC_enum_data = (void *)(local[1]._void.value);
  memset(EXEC_enum_data, 0, 8);

  EXEC_special(SPEC_FIRST, class, object, 0, TRUE);
}


PUBLIC boolean EXEC_enum_next(void)
{
  OBJECT *object;
  CLASS *class;
  boolean defined;
  VALUE *local;

  local = &BP[PC[-1] & 0xFF];

  EXEC_object(local, &class, &object, &defined);
  EXEC_enum_data = (void *)(local[1]._void.value);

  EXEC_enum_stop = FALSE;

  if (EXEC_special(SPEC_NEXT, class, object, 0, FALSE))
    THROW(E_ENUM);

  return EXEC_enum_stop;
}
