/***************************************************************************

  file.h

  The file management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __FILE_H
#define __FILE_H

typedef
  struct {
    short type;
    short mode;
    long size;
    long time;
    boolean hidden;
    }
  PACKED
  FILE_STAT;


#ifndef __FILE_C
EXTERN FILE_STAT FILE_stat_info;
#endif


void FILE_exit(void);

PUBLIC char *FILE_cat(char *path, ...);
PUBLIC int FILE_buffer_length(void);
PUBLIC char *FILE_get_dir(char *path);
PUBLIC char *FILE_get_name(char *path);
PUBLIC char *FILE_get_ext(char *path);
PUBLIC char *FILE_get_basename(char *path);
PUBLIC char *FILE_get(char *path);
PUBLIC char *FILE_set_ext(char *path, char *ext);
PUBLIC char *FILE_getcwd(char *subdir);
PUBLIC char *FILE_readlink(char *link);

PUBLIC void FILE_stat(char *path);
PUBLIC boolean FILE_exist(char *path);
PUBLIC void FILE_dir_first(char *path, char *pattern, long len_pattern);
PUBLIC char *FILE_dir_next(void);
PUBLIC void FILE_unlink(char *path);
PUBLIC void FILE_rmdir(char *path);
PUBLIC void FILE_mkdir(char *path);
PUBLIC void FILE_rename(char *src, char *dst);

#define FILE_is_absolute(_path) (*(_path) == '/')
#define FILE_is_relative(_path) (*(_path) != '/')

#endif
