/***************************************************************************

  gambas_api.h

  Gambas API for external libraries

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __GAMBAS_API_H
#define __GAMBAS_API_H

#include "gambas.h"

PUBLIC void GAMBAS_exit(void);

PUBLIC int GB_GetInterface(char *library, long version, void *iface);
PUBLIC void GB_Declare(void *desc, ...);
PUBLIC void *GB_Hook(int type, void *hook);
PUBLIC int GB_CanRaise(void *object, int event_id);
PUBLIC int GB_Raise(void *object, int event_id, char *param);
PUBLIC void GB_Error(char *msg);
PUBLIC void GB_Ref(void *object);
PUBLIC void GB_Unref(void **object);
PUBLIC void GB_UnrefKeep(void **object, int);
PUBLIC void GB_StopEnum(void);
PUBLIC void *GB_GetEnum(void);
PUBLIC void GB_Return(unsigned long type, ...);
PUBLIC void GB_ReturnInt(long val);
PUBLIC void GB_ReturnBoolean(int val);
PUBLIC void GB_ReturnObject(void *val);
PUBLIC void GB_ReturnNull(void);
PUBLIC void GB_ReturnPtr(unsigned long type, void *value);
PUBLIC void GB_ReturnString(char *str, long len);
PUBLIC void GB_ReturnZeroString(char *str);
PUBLIC void *GB_GetClass(void *object);
PUBLIC void *GB_FindClass(char *name);
PUBLIC char *GB_NewString(long len);
PUBLIC char *GB_CopyString(char *copy, long len);
PUBLIC void GB_FreeString(char *str);
PUBLIC void GB_ReturnNewString(char *str);
PUBLIC long GB_GetReturnType(void);
PUBLIC void GB_LoadFile(char *path, char **addr, long *len);
PUBLIC void GB_ReleaseFile(char **addr, long len);
PUBLIC int GB_IsMissing(int param);
PUBLIC void GB_Attach(void *object, void *parent, char *name);
PUBLIC void GB_Detach(void *object);
PUBLIC void GB_Store(unsigned long type, void *src, void *dst);
PUBLIC void GB_StoreString(GB_STRING src, char **dst);
PUBLIC void GB_StoreObject(void *object, void **dst);
PUBLIC void GB_ReturnCopyString(char *str, long len);
PUBLIC char *GB_ToZeroString(GB_STRING src);
PUBLIC void GB_ReturnDate(long time);
PUBLIC void GB_Watch(int fd, int flag, void *callback, long param);
PUBLIC int GB_New(void **object, char *class_name, char *name, void *parent);
/*PUBLIC void GB_Call(void *object, char *method, char *param, int nparam);*/
PUBLIC void GB_CheckObject(void *object);
PUBLIC int GB_Is(void *object, void *class);
PUBLIC int GB_GetFunction(GB_FUNCTION *func, void *object, char *name, char *sign);
PUBLIC void GB_Call(GB_FUNCTION *_func, char *param);

#ifndef __GAMBAS_API_C
EXTERN void *GAMBAS_Api[];
EXTERN unsigned long GAMBAS_ReturnType;
EXTERN unsigned long GAMBAS_MissingParam;
EXTERN char *GAMBAS_Error;
EXTERN boolean GAMBAS_DoNotRaiseEvent;
#endif

#endif

