/*

  hash.h

  Implmentation d'une table de hachage

  Ce code est une adaptation du code des tables de
  hachage de la GLIB 1.2.8

*/

#ifndef __HASH_H
#define __HASH_H

typedef
  struct _HASH_NODE
  {
    struct _HASH_NODE *next;
  }
  HASH_NODE;

typedef
  struct
  {
    long size;
    long nnodes;
    /*guint frozen;*/
    HASH_NODE **nodes;
    /*GHashFunc hash_func;*/
    /*GCompareFunc key_compare_func;*/
    size_t s_value;
    /*
    int enum_i;
    HASH_NODE *enum_node;
    */
  }
  HASH_TABLE;

#define HASH_TABLE_MIN_SIZE 11
#define HASH_TABLE_MAX_SIZE 13845163


PUBLIC void HASH_TABLE_create(HASH_TABLE **hash, size_t s_value);
PUBLIC void HASH_TABLE_delete(HASH_TABLE **hash);
PUBLIC long HASH_TABLE_size(HASH_TABLE *hash_table);
PUBLIC void *HASH_TABLE_lookup(HASH_TABLE *hash_table, char *key, int len);
PUBLIC void *HASH_TABLE_insert(HASH_TABLE *hash_table, char *key, int len);
PUBLIC void HASH_TABLE_remove(HASH_TABLE *hash_table, char *key, int len);
PUBLIC void *HASH_TABLE_next(HASH_TABLE *hash_table, long *index, HASH_NODE **node);


#endif

