/***************************************************************************

  library.h

  GAMBAS plug-in management routines

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __LIBRARY_H
#define __LIBRARY_H

typedef
  struct {
    long version;
    long func[0];
    }
  INTERFACE;

typedef
  struct {
    char *name;
    char *path;
    void *handle;
    boolean persistent;
    }
  LIBRARY;


#define LIB_INIT         "GB_INIT"
#define LIB_EXIT         "GB_EXIT"
#define LIB_INTERFACE    "GB_INTERFACE"
#define LIB_GAMBAS       "GB"


PUBLIC void LIBRARY_init(void);
PUBLIC void LIBRARY_exit(void);
PUBLIC void LIBRARY_add(char *path);
PUBLIC void LIBRARY_load_all(void);
PUBLIC boolean LIBRARY_get_interface(char *name, long version, void *iface);

#endif
