/***************************************************************************

  subr_test_temp.c

  The test routines templates

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

PUBLIC void STT_NAME(void)
{
  static void *jump[17] = {
    &&_VARIANT, &&_BOOLEAN, &&_BYTE, &&_SHORT, &&_INTEGER, &&_LONG, &&_FLOAT, &&_DATE,
    &&_STRING, &&_STRING, &&_ERROR, &&_ERROR, &&_ERROR, &&_ERROR, &&_ERROR,
#ifdef STT_NULL
    &&_NULL,
#else
    &&_ERROR,
#endif
#ifndef STT_NO_OBJECT
    &&_OBJECT
#else
    &&_ERROR
#endif
    };

  TYPE type;
  VALUE *P1, *P2;
  boolean result, variant;

  P1 = SP - 2;
  P2 = P1 + 1;

  variant = FALSE;
  type = EXEC_code & 0x1F;
  goto *jump[type];

_VARIANT:

  type = Max(P1->type, P2->type);

  if (TYPE_is_variant(P1->type))
  {
    #ifdef STT_CASE
    TEMP = *P1;
    P1 = &TEMP;
    #endif
    VARIANT_undo(P1);
    variant = TRUE;
  }

  if (TYPE_is_variant(P2->type))
  {
    VARIANT_undo(P2);
    variant = TRUE;
  }

  if (variant)
    type = Max(P1->type, P2->type);

  if (TYPE_is_object_null(P1->type) && TYPE_is_object_null(P2->type))
    type = T_OBJECT;
  else if (TYPE_is_object(type))
    THROW(E_TYPE, "Object", TYPE_get_name(Min(P1->type, P2->type)));

  if (!variant)
    *PC |= type;

  goto *jump[type];

_BOOLEAN:
_BYTE:
_SHORT:
_INTEGER:

  result = P1->_integer.value STT_TEST P2->_integer.value;
  goto _END;

_LONG:
  result = FALSE;
  goto _END;

_DATE:

  VALUE_conv(P1, T_DATE);
  VALUE_conv(P2, T_DATE);

  result = (DATE_comp_value(P1, P2) STT_TEST 0);
  goto _END;

_STRING:

  VALUE_conv(P1, T_STRING);
  VALUE_conv(P2, T_STRING);

  result = (STRING_comp_value(P1, P2) STT_TEST 0);

#ifdef STT_CASE
  if (variant)
#endif
  RELEASE_STRING(P1);
  RELEASE_STRING(P2);

  goto _END;

_FLOAT:

  VALUE_conv(P1, T_FLOAT);
  VALUE_conv(P2, T_FLOAT);

  result = P1->_float.value STT_TEST P2->_float.value;
  goto _END;

#ifndef STT_NO_OBJECT

_OBJECT:

  result = OBJECT_comp_value(P1, P2) STT_TEST TRUE;
  goto _END;

#endif

#ifdef STT_NULL

_NULL:

  result = VALUE_is_null(P1->type == T_NULL ? P2 : P1) STT_TEST TRUE;
  goto _END;

#endif

_ERROR:

  #ifndef STT_NO_OBJECT
  THROW(E_TYPE, "Number or Date", TYPE_get_name(type));
  #else
  THROW(E_TYPE, "Number, Date or Object", TYPE_get_name(type));
  #endif

_END:

  #ifdef STT_CASE

  P2->type = T_BOOLEAN;
  P2->_boolean.value = result ? -1 : 0;

  #else

  P1->type = T_BOOLEAN;
  P1->_boolean.value = result ? -1 : 0;
  SP -= 2;
  /*if (!PCODE_is_void(*PC)) SP++;*/

  #endif

}


#undef STT_NAME
#undef STT_TEST

#ifdef STT_NO_OBJECT
#undef STT_NO_OBJECT
#endif

#ifdef STT_CASE
#undef STT_CASE
#endif

#ifdef STT_NULL
#undef STT_NULL
#endif


