/***************************************************************************

  table.h

  Symbol tables management

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __TABLE_H
#define __TABLE_H

#include "array.h"

#define NO_SYMBOL (-1)

typedef
  struct {
    short sort;
    short len;
    char *name;
    }
  PACKED
  SYMBOL;

typedef
  enum {
    TF_NORMAL = 0,
    TF_IGNORE_CASE = 1
    }
  TABLE_FLAG;


typedef
  struct _table {
    SYMBOL *symbol;
    TABLE_FLAG flag;
    }
  TABLE;


PUBLIC void TABLE_create(TABLE *table, size_t size, TABLE_FLAG flag);
PUBLIC void TABLE_delete(TABLE *table);

/*
PUBLIC void TABLE_create_new(TABLE **result, size_t size, TABLE_FLAG flag);
PUBLIC void TABLE_create_new_from(TABLE **result, size_t size, char *sym_list[], TABLE_FLAG flag);
PUBLIC void TABLE_delete_free(TABLE **table);
*/

PUBLIC int compare_ignore_case(char *s1, long len1, char *s2, long len2);

PUBLIC long TABLE_count(TABLE *table);
PUBLIC char *TABLE_get_symbol_name(TABLE *table, long index);
PUBLIC boolean TABLE_find_symbol(TABLE *table, char *name, int len, SYMBOL **symbol, long *index);
PUBLIC boolean TABLE_add_symbol(TABLE *table, char *name, int len, SYMBOL **symbol, long *index);
PUBLIC void TABLE_sort(TABLE *table);
PUBLIC void TABLE_print(TABLE *table, boolean sort);
/*PUBLIC boolean TABLE_copy_symbol(TABLE *dst, TABLE *src, long index_src, SYMBOL **symbol, long *index);*/
PUBLIC void TABLE_add_new_symbol_without_sort(TABLE *table, char *name, int len, long sort, SYMBOL **symbol, long *index);

PUBLIC boolean SYMBOL_find(void *symbol, int n_symbol, size_t s_symbol, int flag, char *name, int len, char *prefix, long *result);

#define TABLE_get_symbol(table, ind) ((SYMBOL *)ARRAY_get((table)->symbol, ind))

#endif
