/***************************************************************************

  CCheckBox.cpp

  The CheckBox class

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CCHECKBOX_CPP

#include "common.h"

#include <qapplication.h>
#include <qcheckbox.h>

#include "gambas.h"

#include "CCheckBox.h"

static long EVENT_Click;


BEGIN_METHOD(CCHECKBOX_new, void *parent)

  QCheckBox *wid = new QCheckBox(CONTAINER(PARAM(parent)));

  QObject::connect(wid, SIGNAL(clicked()), &CCheckBox::manager, SLOT(clicked()));

  QCHECKBOX(_object) = wid;

  CWIDGET_new(wid, (void *)_object, "CheckBox");

  wid->show();

END_METHOD


BEGIN_PROPERTY(CCHECKBOX_text)

  if (READ_PROPERTY)
    GB.ReturnString(QCHECKBOX(_object)->text(), 0);
  else
    QCHECKBOX(_object)->setText(GB.ToZeroString(PROPERTY(GB_STRING)));

END_PROPERTY


BEGIN_PROPERTY(CCHECKBOX_value)

  if (READ_PROPERTY)
    GB.ReturnBoolean(QCHECKBOX(_object)->isChecked());
  else
    QCHECKBOX(_object)->setChecked(PROPERTY(char));

END_PROPERTY


/* Class CCheckBox */

CCheckBox CCheckBox::manager;

void CCheckBox::clicked(void)
{
  RAISE_EVENT(EVENT_Click, NULL);
}

GB_DESC CCheckBoxDesc[] =
{
  GB_DECLARE("CheckBox", sizeof(CCHECKBOX)), GB_INHERITS("Control"),

  GB_METHOD("_new", NULL, CCHECKBOX_new, "Container;"),

  GB_PROPERTY("Text", "s", CCHECKBOX_text),
  GB_PROPERTY("Caption", "s", CCHECKBOX_text),

  GB_PROPERTY("Value", "b", CCHECKBOX_value),

  GB_CONSTANT("_Properties", "s", CCHECKBOX_PROPERTIES),
  GB_CONSTANT("_DefaultEvent", "s", "Click"),

  GB_EVENT("Click", NULL, NULL, &EVENT_Click),

  GB_END_DECLARE
};


