/***************************************************************************

  CClipboard.cpp

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/


#define __CCLIPBOARD_CPP

#include "common.h"
#include "gambas.h"

#include <qapplication.h>
#include <qclipboard.h>
#include <qimage.h>
#include <qpicture.h>

#include "CClipboard.h"


BEGIN_METHOD_VOID(CCLIPBOARD_clear)

  QApplication::clipboard()->clear();

END_METHOD


BEGIN_PROPERTY(CCLIPBOARD_text)

  if (READ_PROPERTY)
    GB.ReturnCopyString(QApplication::clipboard()->text(), 0);
  else
  {
    QApplication::clipboard()->setText(GB.ToZeroString(PROPERTY(GB_STRING)));
  }

END_PROPERTY


BEGIN_PROPERTY(CCLIPBOARD_picture)

  QImage image;
  CPICTURE *picture;

  if (READ_PROPERTY)
  {
    image = QApplication::clipboard()->image();
    if (image.isNull())
      GB.ReturnObject(0);
    else
    {
      GB.New((void **)&picture, "Picture", 0, 0);
      *(picture->pixmap) = image;
      GB.ReturnObject(picture);
    }
  }
  else
  {
    QApplication::clipboard()->setPixmap(*(PROPERTY(CPICTURE *)->pixmap));
  }

END_PROPERTY


GB_DESC CClipboardDesc[] =
{
  GB_DECLARE("Clipboard", 0), GB_VIRTUAL_CLASS(),

  GB_STATIC_METHOD("Clear", NULL, CCLIPBOARD_clear, NULL),
  GB_STATIC_PROPERTY("Text", "s", CCLIPBOARD_text),
  GB_STATIC_PROPERTY("Picture", "Picture", CCLIPBOARD_picture),

  GB_END_DECLARE
};

