/***************************************************************************

  CConst.cpp

  The constants

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CCONST_CPP

#include "common.h"
#include "gambas.h"

#include <qnamespace.h>
#include <qframe.h>

#include "CConst.h"


GB_DESC CAlignDesc[] =
{
  GB_DECLARE("Align", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("Left", "i", Qt::AlignVCenter + Qt::AlignLeft),
  GB_CONSTANT("Right", "i", Qt::AlignVCenter + Qt::AlignRight),
  GB_CONSTANT("Center", "i", Qt::AlignVCenter + Qt::AlignHCenter),

  GB_CONSTANT("TopLeft", "i", Qt::AlignTop + Qt::AlignLeft),
  GB_CONSTANT("TopRight", "i", Qt::AlignTop + Qt::AlignRight),
  GB_CONSTANT("Top", "i", Qt::AlignTop + Qt::AlignHCenter),

  GB_CONSTANT("BottomLeft", "i", Qt::AlignBottom + Qt::AlignLeft),
  GB_CONSTANT("BottomRight", "i", Qt::AlignBottom + Qt::AlignRight),
  GB_CONSTANT("Bottom", "i", Qt::AlignBottom + Qt::AlignHCenter),

  GB_END_DECLARE
};

GB_DESC CBorderDesc[] =
{
  GB_DECLARE("Border", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("None", "i", QFrame::NoFrame /* 0 */),
  GB_CONSTANT("Plain", "i", QFrame::Box + QFrame::Plain),
  GB_CONSTANT("Sunken", "i", QFrame::Panel + QFrame::Sunken),
  GB_CONSTANT("Raised", "i", QFrame::Panel + QFrame::Raised),
  GB_CONSTANT("Etched", "i", QFrame::Box + QFrame::Sunken),

  GB_END_DECLARE
};


GB_DESC CScrollDesc[] =
{
  GB_DECLARE("Scroll", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("None", "i", 0),
  GB_CONSTANT("Horizontal", "i", 1),
  GB_CONSTANT("Vertical", "i", 2),
  GB_CONSTANT("Both", "i", 3),

  GB_END_DECLARE
};


GB_DESC CKeyDesc[] =
{
  GB_DECLARE("Key", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("Escape", "i", Qt::Key_Escape),
  GB_CONSTANT("Tab", "i", Qt::Key_Tab),
  GB_CONSTANT("BackTab", "i", Qt::Key_BackTab),
  GB_CONSTANT("BackSpace", "i", Qt::Key_BackSpace),
  GB_CONSTANT("Return", "i", Qt::Key_Return),
  GB_CONSTANT("Enter", "i", Qt::Key_Enter),
  GB_CONSTANT("Insert", "i", Qt::Key_Insert),
  GB_CONSTANT("Delete", "i", Qt::Key_Delete),
  GB_CONSTANT("Pause", "i", Qt::Key_Pause),
  GB_CONSTANT("Print", "i", Qt::Key_Print),
  GB_CONSTANT("SysReq", "i", Qt::Key_SysReq),
  GB_CONSTANT("Home", "i", Qt::Key_Home),
  GB_CONSTANT("End", "i", Qt::Key_End),
  GB_CONSTANT("Left", "i", Qt::Key_Left),
  GB_CONSTANT("Up", "i", Qt::Key_Up),
  GB_CONSTANT("Right", "i", Qt::Key_Right),
  GB_CONSTANT("Down", "i", Qt::Key_Down),
  GB_CONSTANT("PageUp", "i", Qt::Key_PageUp),
  GB_CONSTANT("PageDown", "i", Qt::Key_PageDown),
  GB_CONSTANT("Shift", "i", Qt::Key_Shift),
  GB_CONSTANT("Control", "i", Qt::Key_Control),
  GB_CONSTANT("Meta", "i", Qt::Key_Meta),
  GB_CONSTANT("Alt", "i", Qt::Key_Alt),
  GB_CONSTANT("CapsLock", "i", Qt::Key_CapsLock),
  GB_CONSTANT("NumLock", "i", Qt::Key_NumLock),
  GB_CONSTANT("ScrollLock", "i", Qt::Key_ScrollLock),
  GB_CONSTANT("F1", "i", Qt::Key_F1),
  GB_CONSTANT("F2", "i", Qt::Key_F2),
  GB_CONSTANT("F3", "i", Qt::Key_F3),
  GB_CONSTANT("F4", "i", Qt::Key_F4),
  GB_CONSTANT("F5", "i", Qt::Key_F5),
  GB_CONSTANT("F6", "i", Qt::Key_F6),
  GB_CONSTANT("F7", "i", Qt::Key_F7),
  GB_CONSTANT("F8", "i", Qt::Key_F8),
  GB_CONSTANT("F9", "i", Qt::Key_F9),
  GB_CONSTANT("F10", "i", Qt::Key_F10),
  GB_CONSTANT("F11", "i", Qt::Key_F11),
  GB_CONSTANT("F12", "i", Qt::Key_F12),
  GB_CONSTANT("F13", "i", Qt::Key_F13),
  GB_CONSTANT("F14", "i", Qt::Key_F14),
  GB_CONSTANT("F15", "i", Qt::Key_F15),
  GB_CONSTANT("F16", "i", Qt::Key_F16),
  GB_CONSTANT("F17", "i", Qt::Key_F17),
  GB_CONSTANT("F18", "i", Qt::Key_F18),
  GB_CONSTANT("F19", "i", Qt::Key_F19),
  GB_CONSTANT("F20", "i", Qt::Key_F20),
  GB_CONSTANT("F21", "i", Qt::Key_F21),
  GB_CONSTANT("F22", "i", Qt::Key_F22),
  GB_CONSTANT("F23", "i", Qt::Key_F23),
  GB_CONSTANT("F24", "i", Qt::Key_F24),
  GB_CONSTANT("Menu", "i", Qt::Key_Menu),
  GB_CONSTANT("Help", "i", Qt::Key_Help),
  GB_CONSTANT("Space", "i", Qt::Key_Space),

  GB_END_DECLARE
};

GB_DESC CLineDesc[] =
{
  GB_DECLARE("Line", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("None", "i", Qt::NoPen),
  GB_CONSTANT("Solid", "i", Qt::SolidLine),
  GB_CONSTANT("Dash", "i", Qt::DashLine),
  GB_CONSTANT("Dot", "i", Qt::DotLine),
  GB_CONSTANT("DashDot", "i", Qt::DashDotLine),
  GB_CONSTANT("DashDotDot", "i", Qt::DashDotDotLine),

  GB_END_DECLARE
};


GB_DESC CFillDesc[] =
{
  GB_DECLARE("Fill", 0), GB_VIRTUAL_CLASS(),

  GB_CONSTANT("None", "i", Qt::NoBrush),
  GB_CONSTANT("Solid", "i", Qt::SolidPattern),
  GB_CONSTANT("Dense94", "i", Qt::Dense1Pattern),
  GB_CONSTANT("Dense88", "i", Qt::Dense2Pattern),
  GB_CONSTANT("Dense63", "i", Qt::Dense3Pattern),
  GB_CONSTANT("Dense50", "i", Qt::Dense4Pattern),
  GB_CONSTANT("Dense37", "i", Qt::Dense5Pattern),
  GB_CONSTANT("Dense12", "i", Qt::Dense6Pattern),
  GB_CONSTANT("Dense6", "i", Qt::Dense7Pattern),
  GB_CONSTANT("Horizontal", "i", Qt::HorPattern),
  GB_CONSTANT("Vertical", "i", Qt::VerPattern),
  GB_CONSTANT("Cross", "i", Qt::CrossPattern),
  GB_CONSTANT("Diagonal", "i", Qt::BDiagPattern),
  GB_CONSTANT("BackDiagonal", "i", Qt::FDiagPattern),
  GB_CONSTANT("CrossDiagonal", "i", Qt::DiagCrossPattern),

  GB_END_DECLARE
};


/*!---------

\HELP
c-align
class

\IN
interface

\TITLE
Align

\TYPE
Static

\DESC:fr
<P>Cette classe statique ne contient que les constantes dfinissant les
modes d'alignement des contrles.</P>
<P>Ces constantes sont les suivantes :</P>

<TABLE BORDER=1 CELLPADDING=2>
  <TR><TD WIDTH=120><B>Align.Left</B></TD><TD>Alignement  gauche.</TD></TR>
  <TR><TD><B>Align.Right</B></TD><TD>Alignement  droite.</TD></TR>
  <TR><TD><B>Align.Center</B></TD><TD>Alignement au centre.</TD></TR>
  <TR><TD><B>Align.Top</B></TD><TD>Alignement horizontal en haut.</TD></TR>
  <TR><TD><B>Align.Bottom</B></TD><TD>Alignement en bas.</TD></TR>
  <TR><TD><B>Align.Middle</B></TD><TD>Alignement vertical au milieu.</TD></TR>
</TABLE>

----------*/

