/***************************************************************************

  CLabel.cpp

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CLABEL_CPP

#include "common.h"

#include <qapplication.h>
#include <qlabel.h>

#include "gambas.h"

#include "CLabel.h"

/*#define DEBUG_CBUTTON*/

#define ALIGN_MASK 0x3F


BEGIN_METHOD(CLABEL_new, void *parent)

  QLabel *wid = new QLabel(CONTAINER(PARAM(parent)));

  CWIDGET_new(wid, (void *)_object, "Label");

  wid->setAlignment(Qt::AlignLeft | Qt::AlignTop | Qt::WordBreak);
  wid->show();

END_METHOD


BEGIN_PROPERTY(CLABEL_text)

  if (READ_PROPERTY)
    GB.ReturnZeroString(WIDGET->text());
  else
    WIDGET->setText(GB.ToZeroString(PROPERTY(GB_STRING)));

END_PROPERTY


BEGIN_PROPERTY(CLABEL_alignment)

  if (READ_PROPERTY)
    GB.ReturnInteger(WIDGET->alignment() & ALIGN_MASK);
  else
    WIDGET->setAlignment((PROPERTY(int) & ALIGN_MASK) | Qt::WordBreak);

END_PROPERTY


BEGIN_PROPERTY(CLABEL_border)

  if (READ_PROPERTY)
    GB.ReturnInteger(WIDGET->frameStyle());
  else
    WIDGET->setFrameStyle(PROPERTY(long));

    /*
  if (READ_PROPERTY)
    GB.ReturnBoolean(QLABEL(_object)->frameStyle() != QFrame::NoFrame);
  else
  {
    if (PROPERTY(char) != 0)
      QLABEL(_object)->setFrameStyle(QFrame::StyledPanel | QFrame::Sunken);
    else
      QLABEL(_object)->setFrameStyle(QFrame::NoFrame);
  }
  */

END_PROPERTY


GB_DESC CLabelDesc[] =
{
  GB_DECLARE("Label", sizeof(CLABEL)), GB_INHERITS("Control"),

  GB_METHOD("_new", NULL, CLABEL_new, "Container;"),

  GB_PROPERTY("Text", "s", CLABEL_text),
  GB_PROPERTY("Caption", "s", CLABEL_text),
  GB_PROPERTY("Alignment", "i<Align>", CLABEL_alignment),
  GB_PROPERTY("Border", "i<Border>", CLABEL_border),

  GB_CONSTANT("_Properties", "s", CLABEL_PROPERTIES),

  GB_END_DECLARE
};


