/***************************************************************************

  CListBox.h

  The ListBox class

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CLISTBOX_H
#define __CLISTBOX_H

#include <qlistbox.h>

#include "gambas.h"

#include "CWidget.h"

#ifndef __CLISTBOX_CPP
extern GB_DESC CListBoxDesc[];
extern GB_DESC CListBoxSelectedDesc[];
#endif

enum {
  SELECT_NONE = 0,
  SELECT_SINGLE = 1,
  SELECT_MULTI = 2,
  SELECT_EXTENDED = 3
  };

typedef
  struct {
    CWIDGET widget;
    }
  CLISTBOX;

#define QLISTBOX(object) ((QListBox *)((CWIDGET *)object)->widget)

#define CONTROL   ((CLISTBOX *)_object)
#define THIS      ((QListBox *)((CWIDGET *)_object)->widget)

#define CLISTBOX_PROPERTIES CWIDGET_PROPERTIES \
  ",Mode"

class MyListBox : public QListBox
{
  Q_OBJECT

public:

  MyListBox(QWidget *parent);

protected:

  void resizeEvent( QResizeEvent *);

};

class CListBox : public QObject
{
  Q_OBJECT

public:

  static CListBox manager;

public slots:

  void selected(void);
  void activated(int);
  void clicked(int);

};


#endif
