/***************************************************************************

  CPanel.cpp

  The Panel class

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CPANEL_CPP

#include "common.h"

#include <qapplication.h>
#include <qframe.h>

#include "gambas.h"

#include "CPanel.h"


BEGIN_METHOD(CPANEL_new, void *parent)

  QFrame *wid = new QFrame(CONTAINER(PARAM(parent)));

  QFRAME(_object) = wid;

  CWIDGET_new(wid, (void *)_object, "Panel");

  OBJECT(CPANEL)->container = wid;

  wid->show();

END_METHOD


BEGIN_PROPERTY(CPANEL_border)

  if (READ_PROPERTY)
    GB.ReturnInteger(QFRAME(_object)->frameStyle());
  else
    QFRAME(_object)->setFrameStyle(PROPERTY(long));

END_PROPERTY


GB_DESC CPanelDesc[] =
{
  GB_DECLARE("Panel", sizeof(CPANEL)), GB_INHERITS("Container"),

  GB_METHOD("_new", NULL, CPANEL_new, "Container;"),

  GB_PROPERTY("Border", "i<Border>", CPANEL_border),

  GB_CONSTANT("_Properties", "s", CPANEL_PROPERTIES),

  GB_END_DECLARE
};


