/***************************************************************************

  CTreeView.h

  The TreeView class

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CTREEVIEW_H
#define __CTREEVIEW_H

#include "gambas.h"

#include <qasciidict.h>
#include <qlistview.h>
#include <qevent.h>

#include "CWidget.h"
#include "CPicture.h"

#ifndef __CTREEVIEW_CPP
extern GB_DESC CTreeViewItemDesc[];
extern GB_DESC CTreeViewDesc[];
extern GB_DESC CListViewDesc[];
#endif

class MyListViewItem;

typedef
  struct {
    CWIDGET widget;
    QAsciiDict<MyListViewItem> *dict;
    boolean sorted;
    //long lock;
    }
  CTREEVIEW;

typedef
  struct {
    GB_OBJECT ob;
    MyListViewItem *item;
    CPICTURE *picture;
    char *key;
    }
  CTREEVIEWITEM;

#define QLISTVIEW(object) ((QListView *)((CWIDGET *)object)->widget)
#define CONTROL QLISTVIEW(_object)

#define CTREEVIEW_PROPERTIES CWIDGET_PROPERTIES \
  ",Mode,Sorted"

#define CLISTVIEW_PROPERTIES CWIDGET_PROPERTIES \
  ",Mode,Sorted"

class MyListViewItem : public QListViewItem
{
public:

  MyListViewItem(QListView *parent);
  MyListViewItem(QListView *parent, MyListViewItem *after);
  MyListViewItem(MyListViewItem *parent);
  MyListViewItem(MyListViewItem *parent, MyListViewItem *after);
  ~MyListViewItem();

  CTREEVIEWITEM item;

  void setPicture(CPICTURE *pict);

private:

  void initData(void);
};


class CTreeView : public QObject
{
  Q_OBJECT

public:

  static CTreeView manager;
  static MyListViewItem *getItem(CTREEVIEW *listview, char *key);
  //static QListViewItem *removeItem(CLISTVIEW *listview, char *key);

public slots:

  void destroy(void);
  void selected(void);
  void activated(void);
  void clicked(QListViewItem *);
  void expanded(QListViewItem *);
  void collapsed(QListViewItem *);
};

#endif
