/***************************************************************************

  CWindow.h

  The Window and Form classes

  (c) 2000-2001 Benot Minisini <gambas@freesurf.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CWINDOW_H
#define __CWINDOW_H

#include <qmainwindow.h>
#include <qasciidict.h>
#include <qmenubar.h>
#include <qptrdict.h>
#include <qevent.h>
#include <qpushbutton.h>

#include "gambas.h"
#include "CContainer.h"
#include "CMenu.h"
#include "CPicture.h"

//class MyCentral;

typedef
  struct {
    CWIDGET widget;
    QWidget *container;
    QAsciiDict<void> *dict;
    CMenuList *menu;
    long ret;
    CPICTURE *icon;
    int border;
    }
  CWINDOW;

typedef
  struct {
    CWINDOW window;
    }
  CFORM;

enum {
  WF_IGNORE_MOVE = (WF_LAST << 1)
  //WF_WIN_DESIGN = (WF_LAST << 2)
  };

#define QMAINWINDOW(object) ((MyMainWindow *)((CWIDGET *)object)->widget)
#define THIS QMAINWINDOW(_object)
#define CONTROL ((CWINDOW *)_object)

#define CWINDOW_PROPERTIES CWIDGET_PROPERTIES \
  ",Text,Icon,Persistent,Border"

#ifndef __CWINDOW_CPP

extern GB_DESC CWindowDesc[];
extern GB_DESC CWindowMenusDesc[];
//extern GB_DESC CWindowToolBarsDesc[];
extern GB_DESC CWindowsDesc[];
extern GB_DESC CFormDesc[];

extern CWINDOW *CWINDOW_Main;

#endif

class CWindow : public QObject
{
  Q_OBJECT

public:

  static QPtrDict<CWINDOW> dict;

  static CWindow manager;
  static int count;

protected:

  bool eventFilter(QObject *, QEvent *);
};

class MyMainWindow : public QMainWindow
{
  Q_OBJECT

private:

  QPushButton *db;
  QPushButton *cb;
  bool shown;

protected:

  void resizeEvent(QResizeEvent *);
  void moveEvent(QMoveEvent *);
  void keyPressEvent(QKeyEvent *);
  void closeEvent(QCloseEvent *);

public:

  enum { BorderNone = 0, BorderFixed = 1, BorderResizable = 2 };

  MyMainWindow(MyMainWindow *);
  ~MyMainWindow();
  void show(void);
  void showModal(void);
  void hide(void);
  void setBorder(int);
  void paintUnclip(bool);
  //QSize MyMainWindow::sizeHint() const;
  bool isPersistent(void);
  void setPersistent(bool);

  QPushButton *defaultButton(void) { return db; }
  QPushButton *cancelButton(void) { return cb; }
  void setDefaultButton(QPushButton *, bool);
  void setCancelButton(QPushButton *, bool);
};

#endif
